Loading...
Searching...
No Matches
Opm::SimpleHuDuanH2O< Scalar > Class Template Reference

A simple version of pure water with density from Hu et al. More...

`#include <SimpleHuDuanH2O.hpp>`

Inheritance diagram for Opm::SimpleHuDuanH2O< Scalar >:

## Static Public Member Functions

static OPM_HOST_DEVICE std::string_view | name ()
| A human readable name for the water.
static OPM_HOST_DEVICE bool | gasIsCompressible ()
| Returns true iff the gas phase is assumed to be compressible.
static OPM_HOST_DEVICE bool | liquidIsCompressible ()
| Returns true iff the liquid phase is assumed to be compressible.
static OPM_HOST_DEVICE bool | gasIsIdeal ()
| Returns true iff the gas phase is assumed to be ideal.
static OPM_HOST_DEVICE Scalar | molarMass ()
| The molar mass in of water.
static OPM_HOST_DEVICE Scalar | criticalTemperature ()
| Returns the critical temperature of water.
static OPM_HOST_DEVICE Scalar | criticalPressure ()
| Returns the critical pressure of water.
static OPM_HOST_DEVICE Scalar | tripleTemperature ()
| Returns the temperature at water's triple point.
static OPM_HOST_DEVICE Scalar | triplePressure ()
| Returns the pressure at water's triple point.
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | vaporPressure (const Evaluation &T)
| The vapor pressure in of pure water at a given temperature.
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | gasEnthalpy (const Evaluation &temperature, const Evaluation &)
| Specific enthalpy of water steam .
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | gasHeatCapacity (const Evaluation &, const Evaluation &)
| Specific isobaric heat capacity of the component [J/kg] as a gas.
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | liquidEnthalpy (const Evaluation &temperature, const Evaluation &)
| Specific enthalpy of liquid water .
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | liquidHeatCapacity (const Evaluation &, const Evaluation &)
| Specific isobaric heat capacity of the component [J/kg] as a liquid.
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | gasInternalEnergy (const Evaluation &temperature, const Evaluation &pressure)
| Specific internal energy of steam .
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | liquidInternalEnergy (const Evaluation &temperature, const Evaluation &pressure, bool extrapolate)
| Specific internal energy of liquid water .
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | liquidThermalConductivity (const Evaluation &, const Evaluation &)
| Specific heat conductivity of liquid water .
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | gasThermalConductivity (const Evaluation &, const Evaluation &)
| Specific heat conductivity of steam .
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | gasDensity (const Evaluation &temperature, const Evaluation &pressure)
| The density of steam at a given pressure and temperature.
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | gasPressure (const Evaluation &temperature, const Evaluation &density)
| The pressure of steam in at a given density and temperature.
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | liquidDensity (const Evaluation &temperature, const Evaluation &pressure, bool extrapolate)
| The density of pure water at a given pressure and temperature .
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | liquidPressure (const Evaluation &, const Evaluation &)
| The pressure of water in at a given density and temperature.
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | gasViscosity (const Evaluation &, const Evaluation &)
| The dynamic viscosity of steam.
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | liquidViscosity (const Evaluation &temperature, const Evaluation &pressure, bool extrapolate)
| The dynamic viscosity of pure water.
Static Public Member Functions inherited from Opm::Component< Scalar, SimpleHuDuanH2O< Scalar > >
static void | init (Scalar, Scalar, unsigned, Scalar, Scalar, unsigned)
| A default routine for initialization, not needed for components and must not be called.
static bool | gasIsCompressible ()
| Returns true iff the gas phase is assumed to be compressible.
static bool | gasIsIdeal ()
| Returns true iff the gas phase is assumed to be ideal.
static bool | liquidIsCompressible ()
| Returns true iff the liquid phase is assumed to be compressible.
static std::string_view | name ()
| A human readable name for the component.
static Scalar | molarMass ()
| The molar mass in of the component.
static Scalar | criticalTemperature ()
| Returns the critical temperature in of the component.
static Scalar | criticalPressure ()
| Returns the critical pressure in of the component.
static Scalar | acentricFactor ()
| Returns the acentric factor of the component.
static Scalar | criticalVolume ()
| Returns the critical volume in of the component.
static Scalar | tripleTemperature ()
| Returns the temperature in at the component's triple point.
static Scalar | triplePressure ()
| Returns the pressure in at the component's triple point.
static Evaluation | vaporPressure (const Evaluation &)
| The vapor pressure in of the component at a given temperature in .
static Evaluation | gasDensity (const Evaluation &, const Evaluation &)
| The density in of the component at a given pressure in and temperature in .
static Evaluation | liquidDensity (const Evaluation &, const Evaluation &)
| The density of the liquid component at a given pressure in and temperature in .
static Evaluation | gasEnthalpy (const Evaluation &, const Evaluation &)
| Specific enthalpy of the pure component in gas.
static Evaluation | liquidEnthalpy (const Evaluation &, const Evaluation &)
| Specific enthalpy of the pure component in liquid.
static Evaluation | gasInternalEnergy (const Evaluation &, const Evaluation &)
| Specific internal energy of the pure component in gas.
static Evaluation | liquidInternalEnergy (const Evaluation &, const Evaluation &)
| Specific internal energy of pure the pure component in liquid.
static Evaluation | gasViscosity (const Evaluation &, const Evaluation &)
| The dynamic viscosity of the pure component at a given pressure in and temperature in .
static Evaluation | liquidViscosity (const Evaluation &, const Evaluation &)
| The dynamic liquid viscosity of the pure component.
static Evaluation | gasThermalConductivity (const Evaluation &, const Evaluation &)
| Thermal conductivity of the component [W/(m^2 K/m)] as a gas.
static Evaluation | liquidThermalConductivity (const Evaluation &, const Evaluation &)
| Thermal conductivity of the component [W/(m^2 K/m)] as a liquid.
static Evaluation | gasHeatCapacity (const Evaluation &, const Evaluation &)
| Specific isobaric heat capacity of the component [J/kg] as a gas.
static Evaluation | liquidHeatCapacity (const Evaluation &, const Evaluation &)
| Specific isobaric heat capacity of the component [J/kg] as a liquid.

## Additional Inherited Members

Public Types inherited from Opm::Component< Scalar, SimpleHuDuanH2O< Scalar > >
typedef Scalar | Scalar
Static Public Attributes inherited from Opm::Component< Scalar, SimpleHuDuanH2O< Scalar > >
static constexpr bool | isTabulated

## Detailed Description

template<class Scalar>
class Opm::SimpleHuDuanH2O< Scalar >

A simple version of pure water with density from Hu et al.

Compared to the water formulation of IAPWS'97, this class provides a much simpler component that represents the thermodynamic properties of pure water. This implies that the likelyhood for bugs in this class is reduced and the numerical performance is increased. (At the cost of accuracy for the representation of the physical quantities, of course.)

Density from Hu, Duan, Zhu and Chou: PVTx properties of the CO2-H2O and CO2-H2O-NaCl systems below 647 K: Assessment of experimental data and thermodynamics models, Chemical Geology, 2007.

Template Parameters

  Scalar | The type used for representing scalar values

## Member Function Documentation

## gasDensity()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::gasDensity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

The density of steam at a given pressure and temperature.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasEnthalpy()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::gasEnthalpy | ( | const Evaluation & | temperature,
|  | const Evaluation & | )

inline static

Specific enthalpy of water steam .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasHeatCapacity()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::gasHeatCapacity | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

Specific isobaric heat capacity of the component [J/kg] as a gas.

## gasInternalEnergy()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::gasInternalEnergy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific internal energy of steam .

      Definition of enthalpy: \f$h= u + pv = u + p / \rho\f$.

      Rearranging for internal energy yields: \f$u = h - pv\f$.

      Exploiting the Ideal Gas assumption (\f$pv = R_{\textnormal{specific}} T\f$)gives: \f$u = h - R / M T \f$.

      The universal gas constant can only be used in the case of molar formulations.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasPressure()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::gasPressure | ( | const Evaluation & | temperature,
|  | const Evaluation & | density )

inline static

The pressure of steam in at a given density and temperature.

Parameters

  temperature | temperature of component in
  density | density of component in

## gasThermalConductivity()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::gasThermalConductivity | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

Specific heat conductivity of steam .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasViscosity()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::gasViscosity | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

The dynamic viscosity of steam.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in
  regularize | defines, if the functions is regularized or not, set to true by default

## liquidDensity()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::liquidDensity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure,
|  | bool | extrapolate )

inline static

The density of pure water at a given pressure and temperature .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in
  extrapolate | Whether to extrapolate for untabulated/unreasonable values. If false an exception might be thrown.

## liquidEnthalpy()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::liquidEnthalpy | ( | const Evaluation & | temperature,
|  | const Evaluation & | )

inline static

Specific enthalpy of liquid water .

Made by fitting a 2nd-degree polynomial to Coolprop data for temperature range [0.1, 99] Celcius with reference temperature = 288.71 K (= 15.56 C) and pressure = 1.01325 bar.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## liquidHeatCapacity()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::liquidHeatCapacity | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

Specific isobaric heat capacity of the component [J/kg] as a liquid.

## liquidInternalEnergy()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::liquidInternalEnergy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure,
|  | bool | extrapolate )

inline static

Specific internal energy of liquid water .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in
  extrapolate | True to use extrapolation

## liquidPressure()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::liquidPressure | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

The pressure of water in at a given density and temperature.

Parameters

  temperature | temperature of component in
  density | density of component in

## liquidThermalConductivity()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::liquidThermalConductivity | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

Specific heat conductivity of liquid water .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## liquidViscosity()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::liquidViscosity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure,
|  | bool | extrapolate )

inline static

The dynamic viscosity of pure water.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in
  extrapolate | Whether to extrapolate for untabulated/unreasonable values. If false an exception might be thrown.

## vaporPressure()

template<class Scalar>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::SimpleHuDuanH2O< Scalar >::vaporPressure | ( | const Evaluation & | T | ) |

inline static

The vapor pressure in of pure water at a given temperature.

Parameters

  T | temperature of component in

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

The documentation for this class was generated from the following file:

- opm/material/components/SimpleHuDuanH2O.hpp